% Excercises with Loops and Vectorizing

%% For Loop
% using a for loop, create a vector that has the squares of the numbers 1 to 10

%% If Loop
% Make a sine wave, and flatten the tops
f=10; % define frequency
t=0.001:0.001:1; % make time base
sine_wave = sin(2*pi*f*t);
plot(sine_wave);
% Now use an if loop to find all values >.6 and set them to .6
    % Note -- looping is an inefficient way to do this...  how else might
    % you do this using indexing?
% Use HOLD and plot clipped wave over the original wave

%% Sample if and for loops
% Preallocate a matrix
nrows = 10;
ncols = 10;
myData = ones(nrows, ncols); % Pre-allocation

% Loop through the matrix
for r = 1:nrows
   for c = 1:ncols

      if r == c
         myData(r,c) = 2;
      elseif abs(r - c) == 1
         myData(r,c) = -1;
      else
         myData(r,c) = 0;
      end

   end
end

%% Switch Demo
mynumber = input('Enter a number:');

switch mynumber
    case -1
        disp('negative one');
    case 0
        disp('zero');
    case 1
        disp('positive one');
    otherwise
        disp('other value');
end

%% While loop
% find first integer n for which factorial n is greater than 100000
n = 1;
nFactorial = 1;
target_big_number = 10000000000;
while nFactorial < target_big_number
    n = n + 1;
    nFactorial = nFactorial * n;
end
disp([num2str(n) ' factorial is greater than ' num2str(target_big_number)]);

% Advanced: Build a for-loop to show target numbers 10, 100, 1000, 10000, 100000, 1000000, 10000000
% hint: big_nums = [10, 100, 1000, 10000, 100000, 1000000, 10000000];


%% For vs Vectorizing Speed ...  a demo
% get set up
clear all
big_num = 10000000;
multiplier = 2;

% Multiply using the "for" method
disp('Working on things...');
tic
for ni = 1:big_num
    x(ni)=multiplier*ni;
end
For_time = toc

% Multiply using vectorizing
tic
y=multiplier*[1:big_num];
Vectorize_time = toc

% is result the same?
zero_if_same = sum(x-y)
