%% Intro to Matlob Topics to cover Day 3

% Getting setup for remainder of the semester with data and EEGLab toolbox
% Download Sample Data and place in your working directory with your m scripts
% Download EEGLab and unzip into a directory of your choosing (but remember where!)
% Create Shortcut to run EEGLab from shortcut bar in Matlab



%% Indexing and logicals
% ==
% ~=
% > >=
% < <=
% |
% &

M1 = rand(1,100); M1 = 100*(M1 - mean(M1));
% find all entries greater than 10
% Find entries equal to 10
% Find all entries greater than 5 and less than 10

%% Exercise 3
edit Exercise3.m

%% Looping
% for
% end
% Make a loop for 5 iterations to display the iteration number
% else
% elseif
% switch
% case
% otherwise
% while
% tic
% toc
% vectorizing (in Excercise 4)
% 
%% Exercise 4
edit Exercise4.m

% see also forloop.m

%% Scripts versus Functions
% scripts just contain code, and can be run from the command line.
% any variables they create are available in the global workspace
clear all;
FunPlot;
% 
% anything that is used in function does not return to the main program,
% unless you pass it back out.  
% Just like in Vegas ...What happens in the function, stays in the
% function...
clear all;
answer = sample_func(99)

% Look at variables in your workspace
% Open Sample_func to look at other variables that never made it out

% Your goal -- write functions to accomplish tasks, and then write a much
% shorter script that calls functions.  This is helpful for several
% reasons:
%  1) Makes deciphering code much easier
%  2) Makes altering code much easier
%  3) Makes porting code to new projects much easier
%  4) Makes sharing code much easier
%  5) Keeps your workspace free of extraneous variables, which:
%    a) Makes it tidier and easier to keep track of things
%    b) Keeps memory use lower
%    c) Avoids inadvertent conflict of variables with same names

% Functions are great, but modules can also be helpful
% Your big unwieldy script can be broken down into smaller modules (scripts)
% (modules)
edit longversion.m
edit shortversion.m



%% Plotting
% figure
% plot  -- plot(y)  or plot(x,y)
% plot3 -- plot(x,y,z) 
%   e.g. t = 0:pi/50:10*pi;
%        plot3(sin(t),cos(t),t)
% scatter
% hist
% fill %e.g.,  fill([1,1,100,100],[1,100,100,1],'r')
% xlabel
% ylabel
% title

% see your Command Quick Reference for colors, linestyles
%
% be sure to also look at mesh, and surface, and ellipsoid
EllipsoidMan
PlayingFrisbee

% Excercise 6


%% Strings and other comparisons
% sprintf -- string print format, returns string
% strcmp, strcmpi -- compares 2 strings, output logical
% strtok - finds parts of strings (looking for a token) -- output strings
% regexp regexpi -- returns position of matched expression -- output linear index
% ismember ~ismember -- returns linear index/indices
% all may be useful for parsing text output from experimental programs


%% File importing and exporting
% csvwrite
% dlmread (or load)
% dlmwrite
% xlsread
% xlswrite
% fprintf (use with fopen, useful for a log file)

%% EEG Lab stuff  
% EEGLab environment
% Importing data
% EEGLab GUI and command history
% plotting and more plotting

%% Preprocessing
edit EEG_Preprocess




