% Playing_frisbee_Robrecht_Van_Der_Wel.m
% March_23_2006
 
close all
clear all
clc
 
figure(1)
set(gcf, 'Color', [.2 .8 .8]);
title('Playing frisbee', 'FontSize', 20);
colormap(autumn);
 
subplot(4,2,[1:6]);
% Frisbee person
% Order is: Head, mouth/hair, eyes, nose, shoulders, torso,
% gluteus,  left arm, left forearm, left hand, right arm,
% right forearm, right hand, right calf, right foot
 
hold on
%Head M/H Eyes Nose Shou Tors GM LA LFA LH RA RFA RH RC RF           
x_1 = [-10  -9.5  -9.2  -9.2  -10  -10  -10  -10  -10  -10 ...
 -8.8  -7.3  -7.2  -9.0  -8.5];
y_1 = [3  3.1  3.1 3.1   3  3   3  4.5  4.5  4.5  1.4   2.4 ...
  3.9  2.5   2.5];
z_1   = [10.7 10.7  10.7 10.3  9  7.3 4.7 8.1  6.5  5   9.2 ...
  9.2   9.2  1.7   .3];
x_rad_1 = [1  .2   .2 .4   1  1  .8  .5  .4  .3  1.8   .4  ...
  .35  .45   .9];
y_rad_1 = [1  .5   1  .2   2  1  .9  .5  .4  .2   .5   1.3 ...
  .4  .4   .3];
z_rad_1 = [1  1   .2 .2   .8  3  .5  1.3  1.3  .5   .5   .4 ...
  .3  1.5   .2];
 
for i = 1:length(x_1)
  [xpos_1 ypos_1 zpos_1]= ...
  ellipsoid(x_1(i),y_1(i),z_1(i),x_rad_1(i),y_rad_1(i),z_rad_1(i));
  surf(xpos_1,ypos_1,zpos_1);
end
shading interp;
light;
 
[xpos_1 ypos_1 zpos_1]=ellipsoid(-13.1,3.6,1.6,.9,.3,.2);
left_foot_1 = surf(xpos_1,ypos_1,zpos_1);
zdir = [0 1 0];
center = [-13.1,3.6,1.6];
rotate(left_foot_1,zdir,50,center);
 
[xpos_1 ypos_1 zpos_1]=ellipsoid(-10.5,3.6,3.75,.6,.5,1.3);
left_thigh_1 = surf(xpos_1,ypos_1,zpos_1);
zdir = [0 1 0];
center = [-10.5,3.6,3.75];
rotate(left_thigh_1,zdir,50,center);
 
[xpos_1 ypos_1 zpos_1]=ellipsoid(-12.1,3.6,2.5,.45,.4,1.5);
left_calf_1 = surf(xpos_1,ypos_1,zpos_1);
zdir = [0 1 0];
center = [-12.1,3.6,2.5];
rotate(left_calf_1,zdir,70,center);
 
[xpos_1 ypos_1 zpos_1]=ellipsoid(-9.4,2.6,3.8,.6,.5,1.3);
right_thigh_1 = surf(xpos_1,ypos_1,zpos_1);
zdir = [0 1 0];
center = [-9.4,2.6,3.8];
rotate(right_thigh_1,zdir,160,center);
 
 
% Catching person
% Order is: Head, hat,mouth/hair, eyes, nose, shoulders, torso,
% gluteus, left arm,
% left forearm, left hand, right arm, right forearm, right hand,
% right thigh,right calf, right foot
hold on
x_2 = [12 12 11.5 11.3 11.3 12 12 12 12 12 12 11 9.8 8.5 12 ...
  12 11.4];
y_2 = [3 3 3.1 3.1 3.1 3 3 3 1.5 1.5 1.5 4.5 4.5 4.5 3.5 3.5 3.5];
z_2 = [10.7 11.5 10.5 10.7 10.3 9 7.3 4.7 8.1 6.5 5 9 9 9 3.9 ...
  1.5 .1];
x_rad_2 = [1 1 .2 .2 .4 1 1 .8 .5 .4 .3 1.3 1.3 .5 .6 .45 .9];
y_rad_2 = [1 1 .5 1 .2 2 1 .9 .5 .4 .2 .5 .4 .2 .5 .4 .3];
z_rad_2 = [1 .2 1 .2 .2 .8 3 .5 1.3 1.3 .5 .5 .4 .3 1.3 1.5 .2];
 
for i = 1:length(x_2)
  [xpos_2 ypos_2 zpos_2]= ellipsoid(x_2(i),y_2(i),z_2(i),...
  x_rad_2(i), y_rad_2(i),z_rad_2(i));
  surf(xpos_2,ypos_2,zpos_2);
end
 
[xpos_2 ypos_2 zpos_2]=ellipsoid(11.3,2.4,4,1.3,.5,.6);
left_thigh_2 = surf(xpos_2,ypos_2,zpos_2);
zdir = [0 1 0];
center = [11.6 2.3 2.4];
rotate(left_thigh_2,zdir,55,center)
 
[xpos_2 ypos_2 zpos_2]=ellipsoid(14,2.5,2.5,.45,.4,1.5);
left_calf_2 = surf(xpos_2,ypos_2,zpos_2);
zdir = [0 1 0];
center = [14 2.5 2.5];
rotate(left_calf_2,zdir,125,center)
 
[xpos_2 ypos_2 zpos_2]=ellipsoid(14.68,2.5,1.2,.9,.3,.2);
left_foot_2 = surf(xpos_2,ypos_2,zpos_2);
zdir = [0 1 0];
center = [14.68 2.5 1.2];
rotate(left_foot_2,zdir,125,center)
 
% Playground
[x y z]=cylinder(20,50,1);
surf(x,y,z);
shading flat;
 
% Frisbee
[x y z] = ellipsoid(0,1,9,1.4,1.4,.2);
surf(x,y,z);
shading flat;
 
grid off
axis off
xlabel('x');
ylabel('y');
zlabel('z');
 
axis equal
set (gca,'view',[134,14], 'AmbientLightColor', [.5,.8,.1]);
camzoom(3);
camtarget([0 0 4]);
 